#include "GetObjects.js"
#include "WaitForDialogDone.js"

function MarkPoints( crv )
{
	var tol = moi.ui.commandUI.distance.value;

	var objs = moi.geometryDatabase.getObjects();
	objs.unlockSelection();
	objs.setProperty( 'showPoints', false );
	crv.showPoints = true;

	moi.geometryDatabase.selectAll();
	objs.setProperty( 'selected', false );

	var crv_list = moi.geometryDatabase.createObjectList();
	crv_list.addObject( crv );

	moi.geometryDatabase.copyToClipboardCommand( crv_list );
	crv.showPoints = false;
	moi.geometryDatabase.pasteFromClipboard();
 
	var pts = moi.geometryDatabase.getSelectedObjects().getPoints();
	var remove_pts = moi.geometryDatabase.createObjectList();
	var keep_pts = moi.geometryDatabase.createObjectList();

	for ( var i = 0; i < pts.length; ++i )
	{
		var ptobj = pts.item(i);
		var this_pt = ptobj.pt;
		var prev_pt = null;
		var next_pt = null;

		if ( i > 0 )
			prev_pt = pts.item(i-1).pt;
		else if ( crv.isClosed )
			prev_pt = pts.item(pts.length-1).pt;

		if ( i < pts.length-1 )
			next_pt = pts.item(i+1).pt;
		else if ( crv.isClosed )
			next_pt = pts.item(0).pt;

		if ( (prev_pt && moi.vectorMath.distance( this_pt, prev_pt ) < tol)
			|| (next_pt && moi.vectorMath.distance( this_pt, next_pt ) < tol) )
		{
			keep_pts.addObject( ptobj );
			continue;
		}

		remove_pts.addObject( ptobj );
	}
	
	moi.geometryDatabase.removeObjects( remove_pts );

	return keep_pts;
}

function MarkCloseTogetherControlPoints()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowCurves();
	
	if ( !GetObjects( objectpicker ) )
		return;

	var curves = objectpicker.objects.getCurves();

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.showUI( 'OptionsPrompt' );
	moi.ui.showUI( 'Options' );
	moi.ui.endUIUpdate();

	if ( !WaitForDialogDone() )
		return;

	var kept = [];

	for ( var i = 0; i < curves.length; ++i )
	{
		var kept_list = MarkPoints( curves.item(i) );
		kept.push( kept_list );
	}

	for ( var i = 0; i < kept.length; ++i )
		kept[i].setProperty( 'selected', true );
}

MarkCloseTogetherControlPoints();
